/* classify.h
 */
#ifndef _CLASSIFY_H
#define _CLASSIFY_H

#include "osl/category/categoryList.h"
#include "osl/category/categoryTraits.h"
#include <boost/static_assert.hpp>
#include <utility>

namespace osl
{
  namespace container
  {
    class MoveLogProbVector;
  }
  namespace category
  {
    using container::MoveLogProbVector;
    /**
     * ƤλؼäƤʬह
     */
    template <class SubCategories>
    struct Classify : public SpecialProbabilityCategory
    {
      BOOST_STATIC_ASSERT(IsCategoryList<SubCategories>::isCategoryList);

      static int minProb() { return 180; } // Ŭ
      static const char *getName() { return "*classify*"; }
      static void generate(const CategoryEnv& env, MoveLogProbVector& out);
      /** ǽ˳ƥ֤ͤ */
      template <class Head, class Tail>
      static int getProb(CategoryList<Head,Tail>, 
			 const CategoryEnv& env, Move m, int pieceValue,
			 int cur);
      template <class Head>
      static int getProb(CategoryList<Head,NullCategory>, 
			 const CategoryEnv& env, Move m, int pieceValue,
			 int cur);
      /** ƤΥƥκǾ֤ͤ */
      template <class Head, class Tail>
      static int
      getMinProb(CategoryList<Head,Tail>,
		 const CategoryEnv& env, Move m, int pieceValue, int cur);
      template <class Head>
      static int
      getMinProb(CategoryList<Head,NullCategory>, 
		 const CategoryEnv& env, Move m, int pieceValue, int cur);
    };
  }
}


#endif /* _CLASSIFY_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
