/* pass.h
 */
#ifndef CATEGORY_PASS_H
#define CATEGORY_PASS_H

#include "osl/category/categoryTraits.h"
#include "osl/category/categoryEnv.h"
#include "osl/search/simpleHashRecord.h"
#include "osl/container/moveStack.h"
#include "osl/container/moveVector.h"
namespace osl
{
  namespace category
  {
    /**
     * ѥ.
     */
    struct Pass : public SpecialProbabilityCategory
    {
      static int minProb() { return 30; } // Ŭ
      static const char *getName() { return "Pass"; }
      static void generate(const CategoryEnv& env, MoveLogProbVector& out)
      {
	const Player turn = env.state->getTurn();
	if (env.record && env.record->threatmate().maybeThreatmate(turn))
	  return;
	const bool is_king_in_check
	  = EffectUtil::isKingInCheck(turn, *env.state);
	if (is_king_in_check)
	  return;
	const Move pass = Move::PASS(turn);
	const int normal_pass_probability = 200;
	const int probability = std::min(normal_pass_probability, env.limit);
	out.push_back(MoveLogProb(pass, probability));
      }
    };
  } // namespace category
} // namespace osl

#endif /* _PAWN_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
