/* probTable.h
 */
#ifndef _PROBTABLE_H
#define _PROBTABLE_H

#include "osl/misc/carray.h"
namespace osl
{
  namespace category
  {
    /**
     * 
     */
    template <int IndexMax>
    class ProbTable
    {
    protected:
      CArray<int,IndexMax> prob;
      int min;
      CArray<char,128> filename;
    public:
      ProbTable();
      virtual ~ProbTable();
      ProbTable(const char *home, const char *name);
      void init(const char *filename);
      int operator[](int i) const 
      {
	assert(initialized()); 
	assert(i < IndexMax);
	return prob[i]; 
      }
      int minProb() const { return min; }
      /** 󥹥ȥ饯ǸƤ֤virtualˤ̣ʤΤǡäƤƤ֤ */
      virtual void interpolate();
      bool initialized() const { return filename[0]; }
      static size_t indexMax() { return IndexMax; }
      /** 0 0 ¸ޤ32 ߤˤ褦Ȼפäα */
      static int roundUp(int val) { return val; /*(val + 31) & (~31);*/ }
    };

    /** 
     * ֤ͤˤʤΨ
     */
    struct FixedValueTable : public ProbTable<1>
    {
      typedef ProbTable<1> base_t;
      FixedValueTable(const char *home, const char *name);
      FixedValueTable(size_t val);
    };

    const size_t PieceValueTableLength = 86;
    /**
     * ɸγΨɽ
     */
    struct PieceValueTable : public ProbTable<PieceValueTableLength>
    {
      typedef ProbTable<PieceValueTableLength> base_t;
      PieceValueTable(const char *home, const char *name);
      void interpolate();
      enum { RANGE = 2750 };
      /**
       * -RANGEʾ64ȤprobͿ롣
       * @param ֤
       */
      static int getIndex(int diff)
      {
	if (diff >= RANGE)
	  return indexMax()-1;
	diff += RANGE;
	if (diff < 0)
	  return 0;
	return diff >> 6;
      }
    };
    
    template <class ProbTable>
    struct Interpolator : public ProbTable
    {
      Interpolator(const char *home, const char *name)
	: ProbTable(home, name)
      {
	ProbTable::interpolate();
      }
    };
    
  } // namespace category
} // namespace osl

#endif /* _PROBTABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
