/* checkTableUtil.h
 */
#ifndef _CHECKTABLEUTIL_H
#define _CHECKTABLEUTIL_H

#include "osl/checkmate/checkHashRecord.h"
#include "osl/hash/hashKey.h"
#include <cassert>
namespace osl
{
  namespace hash
  {
    class HashKey;
  }
  namespace checkmate
  {
    struct CheckTableUtil
    {
      template <class Table>
      static
      void allocate(CheckHashRecord*& record, Table& table, 
		    const HashKey& key, PieceStand white_stand,
		    const PathEncoding& path,
		    CheckHashRecord *parent)
      {
	check_assert(record == 0);
	record = table.allocate(key, white_stand, path);
	if (! record->parent)
	{
	  record->parent = parent;
	  record->distance = parent->distance+1;
	}
      }

      /**
       * white_stand äƤrecordݤ
       */
      template <class Table>
      static
      void allocate(Move last_move, CheckHashRecord*& record, Table& table, 
		    const HashKey& key, const PathEncoding& path,
		    CheckHashRecord *parent)
      {
	assert(parent);
	const PieceStand white_stand
	  = parent->stand(WHITE).nextStand(WHITE, last_move);
	allocate(record, table, key, white_stand, path, parent);
      }

      /**
       * keyBefore  pathBefore  nextMove ؤΤΤˤƤ
       * record ݤ
       */
      template <class Table>
      static
      void allocateNext(Move next_move, 
			CheckHashRecord*& record, Table& table, 
			const HashKey& key_before, 
			const PathEncoding& path_before,
			CheckHashRecord *parent)
      {
	assert(parent);
	const PieceStand white_stand
	  = parent->stand(WHITE).nextStand(WHITE, next_move);
	return allocate(record, table, key_before.newHashWithMove(next_move), 
			white_stand,
			PathEncoding(path_before, next_move), parent);
      }
    };

  } // namespace checkmate
} // namespace osl

#endif /* _CHECKTABLEUTIL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
