/* oraclePool.h
 */
#ifndef _ORACLEPOOL_H
#define _ORACLEPOOL_H

#include "osl/position.h"
#include "osl/player.h"
#include "osl/pieceStand.h"
#include <boost/scoped_ptr.hpp>
#include <cstddef>

namespace osl
{
  namespace state
  {
    class SimpleState;
  }
  namespace checkmate
  {
    class CheckHashRecord;
    using state::SimpleState;
    class OraclePool
    {
      class Table;
      boost::scoped_ptr<Table> proof_oracles;
      boost::scoped_ptr<Table> disproof_oracles;
    public:
      explicit OraclePool(Player attacker);
      ~OraclePool();

      void addProofOracle(const SimpleState&, const CheckHashRecord*);
      void addDisproofOracle(const SimpleState&, const CheckHashRecord*);
      const CheckHashRecord *findProofOracle(const SimpleState&, 
					     PieceStand black_stand,
					     unsigned short& oracle_age) const;
      const CheckHashRecord *findDisproofOracle(const SimpleState&, 
						PieceStand black_stand,
						unsigned short& oracle_age) const;
      size_t totalSize() const;
      size_t keySize() const;
    };

  } // namespace checkmate
} // namespace osl

#endif /* _ORACLEPOOL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
