/* pieceCost.h
 */
#ifndef _PIECECOST_H
#define _PIECECOST_H

#include "osl/checkmate/checkMove.h"
#include "osl/misc/carray.h"
namespace osl
{
  namespace checkmate
  {

    /**
     * »˴Ťcostο
     */
    struct PieceCost
    {
      static const CArray<signed char, PTYPE_SIZE> attack_sacrifice_cost;
      static const CArray<signed char, PTYPE_SIZE> defense_capture_cost;
      
      /** ¦ move Ф cost ׻ */
      template <class State>
      static void setAttackCost(Player attacker, const State&, 
				CheckMove& move);
      /** ɸ¦ move Ф cost ׻ */
      template <class State>
      static void setDefenseCost(Player attacker, const State&, 
				 CheckMove& move);
    };
  } // namespace checkmate
} // namespace osl

template<typename State> inline
void osl::checkmate::PieceCost::
setAttackCost(Player attacker, const State& state, CheckMove& move)
{
  const Position from=move.move.from();
  const Position to=move.move.to();
  const Ptype capturePtype = move.move.capturePtype();
  const Player defender = alt(attacker);
  // ʳǡǤȤϸ
  // 餯ƬˤʤɤǤڤ򥻥åȤˤȤʤɤ
  if (capturePtype == PTYPE_EMPTY)
  {
    const int a = (state.countEffect(attacker,to) 
		   + (from.isPieceStand() ? 1 : 0));
    int d = state.countEffect(defender,to);
    if (a <= d)
    {
      const Ptype ptype = move.move.ptype();
      move.cost_proof = attack_sacrifice_cost[ptype] /* *8 */;
      if ((d >= 2) && (a == d))	// ɲȤ줿Ȥ
	move.cost_proof /= 2;
    }
  }
}

template<typename State> inline
void osl::checkmate::PieceCost::
setDefenseCost(Player attacker, const State& state, CheckMove& move)
{
  const Position to=move.move.to();
  const Ptype capturePtype = move.move.capturePtype();

  // ǤȤˤȤ
  if (! state.hasEffectBy(attacker,to))
  {
    move.cost_disproof = defense_capture_cost[capturePtype];
  }
}


#endif /* _PIECECOST_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
