/* generalSimpleHashTable.h
 */
#ifndef _GENERALSIMPLE_HASHTABLE_H
#define _GENERALSIMPLE_HASHTABLE_H

#include <boost/scoped_ptr.hpp>
#include <stdexcept>

namespace osl
{
  namespace hash
  {
    class HashKey;
  }
  namespace container
  {
  struct TableFull : std::runtime_error
  {
    TableFull() : std::runtime_error("table full")
    {
    }
  };

  /**
   * Ū hash table
   * Ȥꤢ g++ (SGI STL)  hash_map ȤäƼ
   *
   * ǽ:
   * - ⤷ϿƤ̤˺ƤϿä顤ƾ񤭤
   * - ꤬դ줿ñ̵뤹
   *
   * ٴŪʵǽ顤ʬǼʤۤbetter
   *  hash_map Ǥ GC뤳ȤϺȻפ뤿
   *
   * find, allocate  ݥ󥿤֤ᡤǤɲäƤ⡤¸Ǥ
   * ɥ쥹Ѳʤǡ¤Ѥɬפ롥
   */
  template <typename Record>
  class GeneralSimpleHashTable
  {
  protected:
    class Table;
    boost::scoped_ptr<Table> table;
  public:
    typedef hash::HashKey HashKey;

    /**
     * @param capacity ɽݻ
     */
    explicit GeneralSimpleHashTable(unsigned int capacity=100000);
    ~GeneralSimpleHashTable();
    void clear();

    /**
     * ɽõϿƤʤпȥϿ
     * @return ơ֥뤬äѤ
     *   ǤʤǳݤؤΥݥ
     *   (ְäƤ delete ʤ)
     * @throw TableFull
     */
    Record *allocate(const HashKey& key);
    /**
     * ɽõϿϤʤ
     * @return ¸ߤʤ0
     *   ǤʤǳݤؤΥݥ
     *   (ְäƤ delete ʤ)
     */
    Record *find(const HashKey& key);
    const Record *find(const HashKey& key) const;

    unsigned int size() const;
    unsigned int capacity() const;
    int numCacheHit() const;
    int numRecordAfterFull() const;

    bool isVerbose() const;
  };
} // namespace container
  using container::TableFull;
  using container::GeneralSimpleHashTable;
} // namespace osl

#endif /* _GENERALSIMPLE_HASHTABLE_H_ */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
