#ifndef _MOVE_STACK_H
#define _MOVE_STACK_H
#include "osl/container/moveVector.h"
#include "osl/stl/vector.h"
#include <cassert>
namespace osl
{
  namespace container
  {
  /**
   * Move stack. õǺޤǤˤ줿ؼ¸Τ˻.
   * size() == 0 λ lastMove  lastMove(2)  Move::INVALID() ֤.
   */
  class MoveStack
  {
    typedef vector<Move> vector_t;
    vector_t data;
  public:
    MoveStack();
    void clear();
    void push(Move m) { data.push_back(m); }
    void pop() { data.pop_back(); }
    /** @param last lastLastMove if 2 */
    bool hasLastMove(size_t last=1) const { return size()>=last; }
    const Move lastMove(size_t last=1) const
    {
      const size_t index = data.size() - last;
      assert(index < data.size());
      return data[index];
    }
    size_t size() const { return data.size()-2; }
    /**
     * @param last_n ǸnĤɽ0ʤơ
     */
    void dump(size_t last_n=0) const;
  };
} // namespace container
  using container::MoveStack;
} // namespace osl
#endif // _MOVE_STACK_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
