#ifndef _NUM_BITMAP_EFFECT_H
#define _NUM_BITMAP_EFFECT_H

#include "osl/player.h"
#include "osl/container/pieceMask.h"
#include "osl/misc/loki.h"

namespace osl 
{
  namespace effect
  {
    /**
     * ߤ (2005/3/4ʹ)
     * - 0-39 : 0-39
     * - 40-47 : 32-39Ĺ
     * - 48-53 : ο(sentinel碌6bit)
     * - 54-59 : ο(sentinel碌6bit)
     *
     *  (2004/4/13ʹ)
     * - 0-39 : 0-39
     * - 40-47 : 32-39Ĺ
     *
     * 
     * - 0-31 : 0-31ľܸ
     * - 32-39 : 32-39û(obsolete 32-39ûܸ)
     * - 40-47 : 32-39Ĺ(obsolete32-39Ĺܸ)
     */
    class NumBitmapEffect : public PieceMask
    {
    private:
      static NumBitmapEffect playerEffect(misc::Int2Type<BLACK>){
	NumBitmapEffect ret;
	ret.flip(48);
	return ret;
      }
      static NumBitmapEffect playerEffect(misc::Int2Type<WHITE>){
	NumBitmapEffect ret;
	ret.flip(54);
	return ret;
      }
      static mask_t playerEffectMask(misc::Int2Type<BLACK>){
	mask_t mask1=numToMask(54);
	mask1-=numToMask(48);
	return mask1;
      }
      static mask_t playerEffectMask(misc::Int2Type<WHITE>){
	mask_t mask1=numToMask(60);
	mask1-=numToMask(54);
	return mask1;
      }

    public:
      NumBitmapEffect(){
	resetAll();
      }
      template<Player P>
      static NumBitmapEffect playerEffect(){
	return playerEffect(misc::Int2Type<P>());
      }
      static NumBitmapEffect playerEffect(Player pl){
	mask_t mask1=numToMask(54);
	mask1-=numToMask(48);
	mask1&=mask_t::makeDirect(pl);
	mask1+=numToMask(48);
	NumBitmapEffect ret;
	ret.setMask(1,mask1);
	assert((pl==BLACK && ret==playerEffect<BLACK>()) ||
	       (pl==WHITE && ret==playerEffect<WHITE>()));
	return ret;
      }
      template<Player P>
      static mask_t playerEffectMask(){
	return playerEffectMask(misc::Int2Type<P>());
      }
      static mask_t playerEffectMask(Player pl){
	mask_t mask1=numToMask(60);
	mask1-=numToMask(48);
	mask1&=mask_t::makeDirect(pl);
	// pl==BLACK -> mask1 = 0
	// pl==WHITE -> mask1 = 0x0fff0000(32bit), 0x0fff000000000000(64bit)
	mask_t mask2=numToMask(54);
	mask2-=numToMask(48);
	// mask2 = 0x3f0000(32bit), 0x3f000000000000(64bit)
	mask1^=mask2;
	// pl==BLACK -> mask1 = 0x3f0000(32bit), 0x3f000000000000(64bit)
	// pl==WHITE -> mask2 = 0x0fc00000(32bit), 0x0fc0000000000000(64bit)
	assert((pl==BLACK && mask1==playerEffectMask<BLACK>()) ||
	       (pl==WHITE && mask1==playerEffectMask<WHITE>()));
	return mask1;
      }
      int countEffect(Player pl){
	int shift=48+(6&pl);
	mask_t mask=getMask(1);
	mask>>=numToOffset(shift);
	mask&=mask_t::makeDirect(0x3f);
	return static_cast<int>(mask.value());
      }

      template<Player P>
      static NumBitmapEffect makeEffect(int num){
	NumBitmapEffect effect=playerEffect<P>();
	effect.flip(num);
	return effect;
      }
      enum Op{
	Add,Sub,
      };
      NumBitmapEffect& opEqual(NumBitmapEffect const& rhs,
				    misc::Int2Type<Add>){
	*this+=rhs;
	return *this;
      }
      NumBitmapEffect& opEqual(NumBitmapEffect const& rhs,
				    misc::Int2Type<Sub>){
	*this-=rhs;
	return *this;
      }
      template<Op OP>
      NumBitmapEffect& opEqual(NumBitmapEffect const& rhs){
	return opEqual(rhs,misc::Int2Type<OP>());
      }
    };
  } // namespace effect
} // namespace osl
#endif // _NUM_BITMAP_EFFECT_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
