/* eachPlayerProgressEval.h
 */
#ifndef EVAL_EACHPLAYERPROGRESSEVAL_H
#define EVAL_EACHPLAYERPROGRESSEVAL_H

#include "osl/eval/eachPlayerPieceEval.h"
#include "osl/eval/ppair/piecePairRawEval.h"
#include "osl/eval/endgame/attackDefense.h"
#include "osl/progress/effect5x3.h"
#include "osl/state/numEffectState.h"
namespace osl
{
  namespace eval
  {
    /**
     * ץ쥤νפȽפʬȤɾؿ.
     * ɬפǤСפȽפɾؿtemplate parameterˤ롥
     */
    class EachPlayerProgressEval
    {
    public:
      typedef PiecePairRawEval additional_eval_t;
      typedef EachPlayerPieceEval opening_eval_t;
      typedef endgame::AttackDefense endgame_eval_t;
      typedef progress::Effect5x3 progress_t;
    private:
      additional_eval_t additional_eval;
      opening_eval_t opening_eval;
      endgame_eval_t endgame_eval;
      progress_t current_progress;
    public:
      EachPlayerProgressEval(const NumEffectState& state) 
	: additional_eval(state), opening_eval(state), endgame_eval(state),
	  current_progress(state)
      {
      }

      static bool initialized() 
      { 
	return additional_eval_t::initialized()
	  && opening_eval_t::initialized()
	  && endgame_eval_t::initialized();
      } 
      static bool setUp(const char *filename)
      {
	return additional_eval_t::setUp(filename);
      }

      static int composeValue(int value_opening, int value_endgame, 
			      Progress16 progress16)
      {
	assert(progress16.isValid());
	assert(value_opening % 2 == 0);
	assert(value_endgame % 2 == 0);
	const int result = value_opening*(16-progress16.value())
	  + value_endgame*progress16.value();
	assert(result % 2 == 0);
	return result;
      }
      const Progress16 progress16(Player p) const 
      { 
	return current_progress.progress16(p); 
      }
      int value() const
      {
	const int black = 
	  composeValue(opening_eval.value(BLACK), endgame_eval.value(BLACK),
		       progress16(BLACK));
	const int white = 
	  composeValue(opening_eval.value(WHITE), endgame_eval.value(WHITE),
		       progress16(WHITE));
	return black + white + additional_eval.value(); 
      }
      static void setValues(const SimpleState&, 
			    Progress16 black_progress16,
			    Progress16 white_progress16,
			    container::PieceValues&);
      static void setValues(const SimpleState& s, container::PieceValues& o);

      void doSimpleMove(const NumEffectState& state,
			Position from, Position to,  int promote_mask)
      {
	additional_eval.doSimpleMove(state,from,to,promote_mask);
	opening_eval.doSimpleMove(state,from,to,promote_mask);
	endgame_eval.doSimpleMove(state,from,to,promote_mask);
	current_progress.doSimpleMove(state,from,to,promote_mask);
      }
      void doDropMove(const NumEffectState& state,Position to,Ptype ptype)
      {
	additional_eval.doDropMove(state,to,ptype);
	opening_eval.doDropMove(state,to,ptype);
	endgame_eval.doDropMove(state,to,ptype);
	current_progress.doDropMove(state,to,ptype);
      }
      void doCaptureMove(const NumEffectState& state,
			 Position from, Position to, 
			 Piece victim,int promote_mask)
      {
	additional_eval.doCaptureMove(state,from,to,victim,promote_mask);
	opening_eval.doCaptureMove(state,from,to,victim,promote_mask);
	endgame_eval.doCaptureMove(state,from,to,victim,promote_mask);
	current_progress.doCaptureMove(state,from,to,victim,promote_mask);
      }
    public:
      static int infty()
      {
	assert(endgame_eval_t::infty() >= opening_eval_t::infty());
	// פ
	return composeValue(0, endgame_eval_t::infty(), Progress16(15));
      }

      static int captureValue(PtypeO ptypeO)
      {
	// פ
	return composeValue(opening_eval_t::captureValue(ptypeO), 0, 
			    Progress16(0));
      }
    };

  } // namespace eval
} // namespace osl

#endif /* EVAL_PROGRESSEVAL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
