/* pieceEval.tcc
 */
#ifndef _PIECEEVAL_TCC
#define _PIECEEVAL_TCC
#include "osl/effect_action/storePtypeOPosition.h"
#include "osl/move_classifier/kingOpenMove.h"
#include "osl/eval/pieceEval.h"
#include "osl/container/pieceVector.h"
#include "osl/apply_move/applyMove.h"
namespace osl 
{
  namespace eval
  {
    using container::PtypeOPositionVector;
  /**
   * ʻؼ.
   * ñȴϹθ뤬ΤǤϤʤ
   * @param P ؼؤץ쥤
   */
  template <Player P>
  struct SelectSafePieces
  {
    template <class State>
    static void select(const State& state, Position target,
		       const PtypeOPositionVector& src,
		       PtypeOPositionVector& out)
    {
      for (size_t i=0; i<src.size(); ++i)
      {
	assert(P == getOwner(src[i].first));
	const Ptype ptype = getPtype(src[i].first);
	const Position from = src[i].second;
	if ((ptype == KING)	// ̵ǤƤ
	    || (! move_classifier::KingOpenMove<P>::
		isMember(state,ptype,from,target)))
	{
	  out.push_back(src[i]);
	}
      }
    }
    /**
     * @param exceptFor Ͻ
     */
    template <class State>
    static void select(const State& state, Position target,
		       const PtypeOPositionVector& src,
		       PtypeOPositionVector& out, Position exceptFor)
    {
      for (size_t i=0; i<src.size(); ++i)
      {
	assert(P == getOwner(src[i].first));
	const Ptype ptype = getPtype(src[i].first);
	const Position from = src[i].second;
	if ((ptype == KING)	// ̵ǤƤ
	    || (! move_classifier::KingOpenMove<P>::
		isMember(state,ptype,from,target,exceptFor)))
	{
	  out.push_back(src[i]);
	}
      }
    }
  };
  
  struct TakeBackValue
  {
    /** effectTo Τƽ */
    template <class State, Player P>
    static void findEffectPieces(const State& state, Position effectTo,
				 PtypeOPositionVector& myPieces, 
				 PtypeOPositionVector& oppPieces)
    {
      typedef effect_action::StorePtypeOPosition store_t;
      store_t oppPiecesStore(&oppPieces, effectTo);
      state.template forEachEffect<PlayerTraits<P>::opponent,store_t>
	(effectTo, oppPiecesStore);
      if (! oppPieces.empty())
      {
	store_t myPiecesStore(&myPieces, effectTo);
	state.template forEachEffect<P,store_t>(effectTo, myPiecesStore);
      }
    }
    /** move  move.to() Τƽ */
    template <class State, Player P>
    static void findEffectPiecesAfterMove(const State& state, Move move, 
					  PtypeOPositionVector& myPieces, 
					  PtypeOPositionVector& oppPieces)
    {
      using namespace effect_action;
      
      const Position from=move.from();
      const Position to=move.to();
      const Player Opponent = PlayerTraits<P>::opponent;
      StorePtypeOPosition myPiecesStore(&myPieces, to);
      StorePtypeOPosition oppPiecesStore(&oppPieces, to);
      {
	// moveηŪΥޥѤΤĴ
	/** ʬ effectμˤäƤϹ®˵ޤ뤫⤷ʤ */
	/** offsetshort */
	/** knight move0ˤBoard_TableˤбΤϤʤ */
	Offset shortOffset=Board_Table.getShortOffsetNotKnight(Offset32(to,from));
	// knightξѤʤ
	if (! shortOffset.zero()){
	  Piece p;
	  for (Position pos=from-shortOffset; (p=state.getPieceAt(pos)).isEmpty();
	       pos-=shortOffset)
	    ;
	  if (p.isOnBoardByOwner<P>()){
	    // 
	    const int moveMask=Ptype_Table.getMoveMask(p.ptype());
	    Direction dir=Board_Table.getLongDirection<P>(Offset32(to,from));
	    if ((moveMask&dirToMask(dir))!=0){
	      myPiecesStore.store(p);
	    }
	  }
	  else if (p.isOnBoardByOwner<Opponent>()){
	    // 
	    const int moveMask=Ptype_Table.getMoveMask(p.ptype());
	    Direction dir=Board_Table.getLongDirection<P>(Offset32(from,to));
	    if ((moveMask&dirToMask(dir))!=0){
	      oppPiecesStore.store(p);
	    }
	  }
	}
      }
      state.template forEachEffect<PlayerTraits<P>::opponent,StorePtypeOPosition>
	(to, oppPiecesStore);
      if (! oppPieces.empty())
      {
	const Piece movePiece=state.getPieceAt(from);
	state.template forEachEffectNotBy<P,StorePtypeOPosition>
	  (to, movePiece,myPiecesStore);
      }
    }
    
    /**
     * PtypeOPositionVector Ȥ˼֤ͤ׻
     * 
     * FIXME: Фɤ PtypeOPositionVector  
     * PtypeO,Position Υ٥ѹɬפ롥 
     * computeDiffAfterMoveMulti ʤɤǶưˡ
     * move μ礤ͤƤˡpiece.position() ɬ
     * 礤Τposition ǤϤʤᡥ
     *
     * @param P alt(P) μ֤
     * @param target ˴ؤ֤
     * @param ptypeo target ˤꤵ
     */
    template <Player P>
    static int computeValue(Position target, PtypeO ptypeO, 
			    const PtypeOPositionVector& myPieces, 
			    const PtypeOPositionVector& oppPieces)
    {
      int val = 0;
      CArray<int,Piece::SIZE> vals;
      const Player Opponent = PlayerTraits<P>::opponent;
      size_t i;
      for (i=0;i<oppPieces.size();i++)
      {
	vals[i*2]=val;
	// opponentMove
	val+=Ptype_Eval_Table.captureValue(ptypeO);
	{
	  ptypeO = oppPieces[i].first;
	  const bool promotable = canPromote(ptypeO) 
	    && (target.canPromote<Opponent>() 
		|| oppPieces[i].second.canPromote<Opponent>());
	  if (promotable)
	  {
	    ptypeO=promote(ptypeO);
	    val+=Ptype_Eval_Table.promoteValue(ptypeO);
	  }
	}
	vals[i*2+1]=val;
	// myMove
	if (i>=myPieces.size()){
	  break;
	}
	val+=Ptype_Eval_Table.captureValue(ptypeO);
	{
	  ptypeO=myPieces[i].first;
	  const bool promotable = canPromote(ptypeO) 
	    && (target.canPromote<P>() 
		|| myPieces[i].second.canPromote<P>());
	  if (promotable)
	  {
	    ptypeO=promote(ptypeO);
	    val+=Ptype_Eval_Table.promoteValue(ptypeO);
	  }
	}
      }
      for (int j=i-1;j>=0;j--)
      {
	val=EvalTraits<P>::max(val,vals[j*2+1]);
	val=EvalTraits<Opponent>::max(val,vals[j*2]);
      }
      return val;
    }
  };

  /** P  PTYPE ζä */
  template <Ptype PTYPE> inline int captureVal(Player P)
  {
    // unpromote(PTYPE) ǵ¨ͤ˽
    return Ptype_Eval_Table.captureValue(newPtypeO(alt(P),PTYPE));
  }
} // namespace eval
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::
computeDiffAfterTakeBackLimited(const State& state, Position focus)
{
  const Piece target = state.getPieceOnBoard(focus);
  assert(target.isPiece());
  assert(P == target.owner());

  PtypeOPositionVector myPieces,oppPieces;
  TakeBackValue::findEffectPieces<State,P>(state, focus, 
					   myPieces, oppPieces);

  if (oppPieces.empty())
    return 0;

  PtypeOPositionVector mySafePieces, oppSafePieces;
  SelectSafePieces<P>::
    select(state, focus, myPieces, mySafePieces);
  SelectSafePieces<PlayerTraits<P>::opponent>::
    select(state, focus, oppPieces, oppSafePieces);
  
  mySafePieces.sort();
  oppSafePieces.sort();

  return TakeBackValue::computeValue<P>(focus, target.ptypeO(), 
					mySafePieces, oppSafePieces);
}

template<class State, osl::Player P>
int osl::PieceEval::
computeDiffAfterMove(const State& state, Move move)
{
  assert(P == state.getTurn());
  assert(state.isAlmostValidMove(move));

  /** move.to() Τ򽸤 */
  PtypeOPositionVector myPieces,oppPieces;
  /**
   * moveη, Ӥ뤫
   */ 
  const Position from=move.from();
  const Position to=move.to();
  int val=0; 
  /**
   * Ǽʬ٤Ƥζ
   */
  if (from.isPieceStand()) // drop moveϴñ
  {
    TakeBackValue::findEffectPieces<State,P>(state, to, 
					     myPieces, oppPieces);
  }
  else
  {
    val+=diffWithMove(state,move);
    TakeBackValue::
      findEffectPiecesAfterMove<State,P>(state, move, myPieces, oppPieces);
  }

  if (oppPieces.empty())
    return val;

  PtypeOPositionVector mySafePieces, oppSafePieces;
  if (from.isPieceStand())
  {
    SelectSafePieces<P>::
      select(state, to, myPieces, mySafePieces);
    SelectSafePieces<PlayerTraits<P>::opponent>::
      select(state, to, oppPieces, oppSafePieces);
  }
  else
  {
    SelectSafePieces<P>::
      select(state, to, myPieces, mySafePieces, from);
    SelectSafePieces<PlayerTraits<P>::opponent>::
      select(state, to, oppPieces, oppSafePieces, from);
  }
  
  mySafePieces.sort();
  oppSafePieces.sort();

  return val + TakeBackValue::
    computeValue<P>(to, move.ptypeO(), mySafePieces, oppSafePieces);
}

namespace osl
{
namespace eval
{
  /**
   * ؼμ֤ͤɾ
   * P ζõƤǤμ礤
   * alt(P) λɤʤ result 򹹿롥
   */
  template <class State,Player P>
  struct UpdateTakeBackAfterMove
  {
    const State& state;
    int& bestValue;
    const Position moveTo, moveFrom;
    const Piece captured;
    const PtypeO movedType;
    UpdateTakeBackAfterMove(const State& s, Move m, int &v) 
      : state(s), bestValue(v), moveTo(m.to()), moveFrom(m.from()),
	captured(s.getPieceAt(moveTo)), movedType(m.ptypeO())
    {
    }
    void operator()(Piece targetPiece)
    {
      using namespace effect_action;
      
      if (targetPiece.position() == moveFrom)	// ư
	return;
      const Position target = targetPiece.position();
      PtypeOPositionVector myPieces, oppPieces;
      StorePtypeOPosition myPiecesStore(&myPieces, target), 
	oppPiecesStore(&oppPieces, target);

      if (captured.isPiece())
	state.template forEachEffectNotBy<PlayerTraits<P>::opponent,StorePtypeOPosition>
	  (target, captured, oppPiecesStore);
      else
	state.template forEachEffect<PlayerTraits<P>::opponent,StorePtypeOPosition>
	  (target, oppPiecesStore);

      if (oppPieces.empty())
	return;

      if (moveFrom.isPieceStand())
	state.template forEachEffect<P,StorePtypeOPosition>
	  (target, myPiecesStore);
      else
	state.template forEachEffectNotBy<P,StorePtypeOPosition>
	  (target, state.getPieceAt(moveFrom), myPiecesStore);

      if (state.hasEffectFromTo(movedType, moveTo, target))
      {
	myPieces.push_back(std::make_pair(movedType, moveTo));
      }
      // CAVEAT: ưȡȴη׻ѹɬפ
      PtypeOPositionVector mySafePieces, oppSafePieces;
      SelectSafePieces<P>::
	select(state, target, myPieces, mySafePieces);
      SelectSafePieces<PlayerTraits<P>::opponent>::
	select(state, target, oppPieces, oppSafePieces);
  
      mySafePieces.sort();
      oppSafePieces.sort();

      const int cur
	= TakeBackValue::computeValue<P>
	(target, targetPiece.ptypeO(), mySafePieces, oppSafePieces);

      if (EvalTraits<PlayerTraits<P>::opponent>::betterThan(cur, bestValue))
	bestValue = cur;
    }
  };
} // namespace eval
} // namespace osl

template<class State, osl::Player P>
int osl::PieceEval::computeDiffAfterMoveMulti(const State& state,Move move)
{
  assert(P == state.getTurn());
  assert(P == move.player());
  assert(state.isAlmostValidMove(move));

  const Player Opp = PlayerTraits<P>::opponent;
  int bestValue = computeDiffAfterMove<State,P>(state, move);
  // computeDiffAfterMove 2ƤǤ̵̤ɤνʣ򤱤
  const int directDiff = diffWithMove(state,move);
  bestValue -= directDiff;
  
  // դ if ʬư promotion ΤǤʤ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PROOK>(Opp)))
    return bestValue+directDiff;
  typedef UpdateTakeBackAfterMove<State,P> updator_t;
  updator_t updator(state, move, bestValue);
  state.template forEachOnBoard<P,ROOK,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PBISHOP>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,BISHOP,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<GOLD>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,GOLD,updator_t>(updator);
  // ä϶Ʊ  ɤøʤΤǻ޴ͥ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<SILVER>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,SILVER,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<KNIGHT>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,KNIGHT,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<LANCE>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,LANCE,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PAWN>(Opp)))
    return bestValue+directDiff;
  state.template forEachOnBoard<P,PAWN,updator_t>(updator);
  return bestValue+directDiff;
}

namespace osl
{
namespace eval
{
  /**
   * P ζõƤǤμ礤
   * alt(P) λɤʤ result 򹹿롥
   */
  template <class State,Player P>
  struct UpdateTakeBack
  {
    const State& state;
    int& bestValue;
    UpdateTakeBack(const State& s, int &v) 
      : state(s), bestValue(v)
    {
    }
    void operator()(Piece target)
    {
      const int cur = PieceEval::
	computeDiffAfterTakeBackLimited<State,P>(state, target.position());

      if (EvalTraits<PlayerTraits<P>::opponent>::betterThan(cur, bestValue))
	bestValue = cur;
    }
  };
} // namespace eval
} // namespace osl

template<class State, osl::Player P>
int osl::eval::PieceEval::computeDiffAfterTakeBackMulti(const State& state)
{
  const Player Opp = PlayerTraits<P>::opponent;
  int bestValue = 0;
  
  // դ if ʬư promotion ΤǤʤ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PROOK>(Opp)))
    return bestValue;
  typedef UpdateTakeBack<State,P> updator_t;
  updator_t updator(state, bestValue);
  state.template forEachOnBoard<P,ROOK,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PBISHOP>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,BISHOP,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<GOLD>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,GOLD,updator_t>(updator);
  // ä϶Ʊ  ɤøʤΤǻ޴ͥ
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<SILVER>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,SILVER,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<KNIGHT>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,KNIGHT,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<LANCE>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,LANCE,updator_t>(updator);
  if (EvalTraits<Opp>::notLessThan(bestValue, captureVal<PAWN>(Opp)))
    return bestValue;
  state.template forEachOnBoard<P,PAWN,updator_t>(updator);
  return bestValue;
} 

#endif /* _PIECEEVAL_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
