/* computerPlayer.h
 */
#ifndef GAME_PLAYING_COMPUTERPLAYER_H
#define GAME_PLAYING_COMPUTERPLAYER_H

#include "osl/move.h"
#include "osl/misc/carray.h"
#include <boost/scoped_ptr.hpp>
namespace osl
{
  namespace game_playing
  {
    class GameState;
    class ComputerPlayer
    {
    protected:
      bool speculative_search_allowed;
    public:
      ComputerPlayer() : speculative_search_allowed(false)
      {
      }
      virtual ~ComputerPlayer();
      /** new Τ֤ */
      virtual ComputerPlayer* clone() const = 0;

      virtual void pushMove(Move m)=0;
      virtual void popMove()=0;
      /** @return success to stop */
      virtual bool isReasonableMove(const GameState&,
				    Move move, int pawn_sacrifice);
      /**
       * @param seconds Ĥ
       */
      virtual const Move selectBestMove(const GameState&, int seconds,
					int byoyomi)=0;

      /**
       * ֤õĤ (GameManager )
       */
      virtual void allowSpeculativeSearch(bool value);
    };

    /**
     * λ
     */
    class ResignPlayer : public ComputerPlayer
    {
    public:
      ~ResignPlayer();
      ComputerPlayer* clone() const 
      {
	return new ResignPlayer();
      }
      void pushMove(Move m);
      void popMove();
      const Move selectBestMove(const GameState&, int, int);
    };

    /**
     * ˡ˻ؤ
     */
    class RandomPlayer : public ComputerPlayer
    {
    public:
      ComputerPlayer* clone() const 
      {
	return new RandomPlayer();
      }
      ~RandomPlayer();
      void pushMove(Move m);
      void popMove();
      const Move selectBestMove(const GameState&, int, int);
    };

  } // namespace game_playing
} // namespace osl

#endif /* GAME_PLAYING_COMPUTERPLAYER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
