/* speculativeSearchPlayer.h
 */
#ifndef OSL_SPECULATIVESEARCHPLAYER_H
#define OSL_SPECULATIVESEARCHPLAYER_H

#include "osl/game_playing/computerPlayer.h"
#include <boost/shared_ptr.hpp>
#include <boost/scoped_ptr.hpp>

namespace osl
{
  namespace game_playing
  {
    class SearchPlayer;
    /**
     * õ
     */
    class SpeculativeSearchPlayer : public ComputerPlayer
    {
      boost::scoped_ptr<SearchPlayer> main_player;
      struct SpeculativeThread;
      boost::scoped_ptr<SpeculativeThread> speculative_thread0;
      boost::scoped_ptr<SpeculativeThread> speculative_thread1;
      boost::shared_ptr<GameState> previous_state;
      Player my_turn;
      int max_threads;
    public:
      /** ͭž */
      SpeculativeSearchPlayer(Player my_turn, SearchPlayer *, 
			      int max_threads=1);
      ~SpeculativeSearchPlayer();
      ComputerPlayer* clone() const;

      void pushMove(Move m);
      void popMove();
      bool stopSearchNow();
      void setMaxThreads(int new_max_threads)
      {
	max_threads = new_max_threads;
      }

      const Move selectBestMove(const GameState&, int seconds, int byoyomi);
    };
  } // game_playing
} // osl

#endif /* OSL_SPECULATIVESEARCHPLAYER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
