/* tableStack.h
 */
#ifndef OSL_TABLESTACK_H
#define OSL_TABLESTACK_H

#include "osl/hash/hashKey.h"
#include <boost/scoped_ptr.hpp>
namespace osl
{
  namespace search
  {
    class SimpleHashTable;
  } // namespace search
  using search::SimpleHashTable;
  namespace game_playing
  {
    /**
     * SimpleHashTable ꥵޤݻ. ؼ֤ǶɽκѤٱ.
     */
    class TableStack
    {
    public:
      static const size_t max_size = 2;
      static const int migration_depth = 16;
      static const int migration_limit = 200;
    private:
      class TableWithRoot;
      class Stack;
      boost::scoped_ptr<Stack> stack;
    public:
      TableStack();
      TableStack(const TableStack&);
      ~TableStack();
      /** ʬؤ */
      void pushMove(Move selected, const HashKey& root, const SimpleHashTable&);
      /** ꤬ؤ */
      void pushMove(Move);
      void popMove();

      void migrate(SimpleHashTable&) const;
    };
  } // game_playing
} // osl

#endif /* OSL_TABLESTACK_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
