/* moveAdaptor.h
 */
#ifndef _MOVE_CLASSIFIER_MOVE_ADAPTOR_H
#define _MOVE_CLASSIFIER_MOVE_ADAPTOR_H

#include "osl/move.h"
#include "osl/position.h"
#include "osl/ptype.h"
namespace osl
{
  namespace move_classifier
  {
    template <class Classifier>
    struct MoveAdaptor
    {
      template <class State>
      static bool isMember(const State& state, Move m) 
      {
	return Classifier::isMember(state, m.ptype(), m.from(), m.to());
      }
    };

    template <template <Player> class Classifier>
    struct PlayerMoveAdaptor
    {
      template <class State>
      static bool isMember(const State& state, Move m) 
      {
	assert(m.player() == state.getTurn());
	if (state.getTurn() == BLACK)
	  return Classifier<BLACK>::isMember(state, m.ptype(), m.from(), m.to());
	else
	  return Classifier<WHITE>::isMember(state, m.ptype(), m.from(), m.to());
      }
    };
  } // namespace move_classifier
} // namespace osl

#endif /* _MOVE_CLASSIFIER_MOVE_ADAPTOR_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
