#ifndef _CSARECORD_H
#define _CSARECORD_H

#include "osl/record/record.h"
#include "osl/record/csa.h"
#include <string>
#include <iosfwd>
namespace osl
{
  namespace record
  {
    namespace csa
    {
      class ICsaRecordStream : public IRecordStream
      {
      private:
	std::istream& is;
	SimpleState state;
	RecordVisitor rv;
      public:
	ICsaRecordStream(std::istream& is);
	virtual ~ICsaRecordStream();

	/** @throw CsaIOError */
	virtual void load(Record*);
	SimpleState getState() const { return state;}
      };

      class CsaFile
      {
      private:
	Record rec;
      public:
	CsaFile(std::string fileName);
	Record const& getRecord() const;
	SimpleState const& getInitialState() const;
      };

    } // namespace csa
  } // namespace record
  using record::csa::CsaFile;

} // namespace osl
#endif /* _CSARECORD_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
