/* dotWriter.h
 */
#ifndef _DOTWRITER_H
#define _DOTWRITER_H

#include "osl/search/analyzer/logWriter.h"
#include <boost/scoped_ptr.hpp>

namespace osl
{
  namespace hash
  {
    class HashKey;
  }
  namespace search
  {
    class SimpleHashTable;

    namespace analyzer
    {
      class RecordSet;
      /**
       * õ dot (www.graphviz.org) Ѥ񤭽Ф.
       */
      class DotWriter : public LogWriter
      {
	/**
	 * ˽񤤤Ρɤ¸.
	 * CAVEAT: from,  to ξ񤯤 from -> to Υå񤫤ʤ
	 */
	boost::scoped_ptr<RecordSet> written;
	std::ostream& os;
      public:
	explicit DotWriter(std::ostream& os);
	~DotWriter();
	void showNode(Player turn, const SimpleHashRecord *record, 
		      int limit, NodeType type) const;
	void showNodeQuiescence(Player turn, 
				const SimpleHashRecord *record, 
				int limit, NodeType type) const;
	void showArc(const SimpleHashRecord *from,
		     const SimpleHashRecord *to,
		     const MoveLogProb& move, bool important) const;
	void showComment(const char *line) const;
      };
    } // namespace analyzer
  } // namespace search
} // namespace osl

#endif /* _DOTWRITER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
