/* bigramKillerMove.h
 */
#ifndef _BIGRAMKILLERMOVETABLE_H
#define _BIGRAMKILLERMOVETABLE_H

#include "osl/state/numEffectState.h"
#include "osl/misc/carray2d.h"
#include "osl/container/moveVector.h"
#include <cstddef>
#include <cassert>
namespace osl
{
  namespace search
  {
    /**
     * λؼ˴Ťkiller move
     */
    class BigramKillerMove
    {
    private:
      CArray2d<Move,Position::SIZE,PTYPEO_SIZE> killer_moves;
    public:
      BigramKillerMove();
      ~BigramKillerMove();
      void clear();
      void setMove(Move key, Move value)
      {
	if (value.isPass())
	  return;
	if (key.to() == value.to())
	  return;		// takeback ɤߤ
	assert(value.isValid());
	assert(key.player() != value.player());
	killer_moves[key.to().index()][ptypeOIndex(key.ptypeO())] = value;
      }
      const Move operator[](Move key) const
      {
	return killer_moves[key.to().index()][ptypeOIndex(key.ptypeO())];
      }
      void getMove(const NumEffectState& state, Move last_move,
		   MoveVector& moves) const
      {
	if (last_move.isInvalid())
	  return;

	Move bigram_move = operator[](last_move);
	if (bigram_move.isInvalid())
	  return;
	const Ptype ptype = bigram_move.oldPtype();
	const Position from = bigram_move.from();
	if ((! from.isPieceStand())
	    && (state.getPieceOnBoard(from).ptype() != ptype))
	{
	  if (! Ptype_Table.hasLongMove(ptype))
	    return;
	  assert(isPiece(ptype));
	  const Position to = bigram_move.to();
	  const Player player = state.getTurn();
	  const PieceMask pieces 
	    = state.getOnBoardMask(player) & state.getEffect(to);
	  // to Ʊptype н
	  for (int i=Ptype_Table.getIndexMin(unpromote(ptype)); 
	       i<Ptype_Table.getIndexLimit(unpromote(ptype)); ++i)
	  {
	    if (pieces.test(i))
	    {
	      const Piece moving = state.getPieceOf(i);
	      assert(moving.owner() == player);
	      if (moving.ptype() != ptype)
		continue;
	      const Position new_from = moving.position();
	      const bool promote = (! isPromoted(ptype))
		&& (to.canPromote(player) || new_from.canPromote(player));
	      bigram_move = Move(new_from, to, 
				 (promote
				  ? osl::promote(moving.ptype()) : moving.ptype()),
				 bigram_move.capturePtype(), 
				 promote, player);
	      assert(state.isValidMoveByRule(bigram_move,false));
	      break;
	    }
	  }
	}
	if (state.isAlmostValidMove<false>(bigram_move))
	  moves.push_back(bigram_move);
      }
      void dump() const;
    };
  } // namespace search
} // namespace osl

#endif /* _BIGRAMKILLERMOVETABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
