/* nullWindowSearch.h
 */
#ifndef _NULLWINDOW_SEARCH_H
#define _NULLWINDOW_SEARCH_H

#include "osl/search/searchFramework.h"

namespace osl
{
  namespace search
  {
    /**
     * null window search.
     *
     *   mtdf ƤִطǡmoveؤͤĴ٤ؿ
     *   
     *   nullWindowSearchAfterMove ϰʲεǽġ
     *   - null window search
     *   - õ
     *   - ơõ
     */
    template<typename Eval, typename MoveGenerator,
	     typename Table, 
	     typename Recorder, 
	     typename Probabilities=RealizationProbability>
    class NullWindowSearch
      : public SearchFramework<Eval,MoveGenerator,Table,Recorder,Probabilities>
    {
      BOOST_CLASS_REQUIRE(Eval, osl::eval, Concept);
      typedef SearchFramework<Eval,MoveGenerator,Table,Recorder,
			      Probabilities> framework_t;
    protected:
      NullWindow null_window;
    public:
      const NullWindow nullWindow() const { return null_window; }
      explicit NullWindowSearch(const HashEffectState& s, 
				typename framework_t::checkmate_t& checker,
				Table *t, Recorder& r);
      ~NullWindowSearch();
      
      /** 
       * entrance of null window search.
       * rootDepth, curLimit are initialized here.
       * @param P turn
       * @return estimate of evaluation after move
       */
      template <Player P>
      int nullWindowSearch(int threshold, const SearchMove& move, 
			   int limit);
      int nullWindowSearchOfTurn(int threshold, const SearchMove& move, 
				 int limit);
      /**
       * (private) 
       * õޤ move õmax_value  bestMove (ǽʤ).
       *
       * @return cut Ǥ뤫
       * @param max_value max(val,max_value) ˹
       * @param best_move_extension true ξ cut ʤǤϺõ
       *   false ʤ cut õ
       */
      template<Player P, bool best_move_extension>
      bool nullWindowSearch(const SearchMove& move, 
			    int& max_value, SearchMove& bestMove);
      /**
       * (private) 
       * õޤ move õmax_value  bestMove (ǽʤ).
       *
       * Υ᥽åɤPμ֤ doMove Ԥơ alt(P) μ
       * Υ᥽åɤȴ undoMove  Pμ֤
       * @return P λǺɾ
       * @param base_value ɾͤ򹹿Ȥߤʤƺõ򤹤
       * @param best_move_extension true ξ cut ʤǤϺõ
       *   false ʤ cut õ
       */
      template<Player P, bool best_move_extension>
      int nullWindowSearchAfterMove(const SearchMove& move, int base_value);
    private:
      template<Player P>
      int normalSearch(const SearchMove& moved, int logprob, 
		       int base_value, SearchMove& bestMove);
    }; // class NullWindowSearch
  } // namespace search
  using search::NullWindowSearch;
} // namespace osl

#endif /* _NULLWINDOW_SEARCH_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
