/* quiescenceWindow.h
 */
#ifndef _QUIESCENCEWINDOW_H
#define _QUIESCENCEWINDOW_H
#include "osl/search/searchWindow.h"
#include "osl/search/fixedEval.h"
#include <utility>
namespace osl
{
  namespace search
  {
    template <class Window> struct QuiescenceWindow;
    
    template <> struct QuiescenceWindow<NullWindow>
    {
      template <class Eval> 
      static const std::pair<int,int> 
      make(Player P, NullWindow window, Eval ev);
    };
    
    template <> struct QuiescenceWindow<AlphaBetaWindow>
    {
      template <class Eval> 
      static const std::pair<int,int>
      make(Player P, const AlphaBetaWindow& window, Eval ev)
      {
	return std::make_pair(window.alpha(), window.beta());
      }
    };

  } // namespace search
} // namespace osl

#endif /* _QUIESCENCEWINDOW_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
