/* searchMoveSet.h
 */
#ifndef _SEARCHMOVESET_H
#define _SEARCHMOVESET_H

#include "osl/container/linearMoveMap.h"
#include "osl/search/searchMove.h"
#include <iosfwd>

namespace osl
{
  namespace search
  {
    struct SearchMoveSet : public LinearMoveMap<search::SearchMove>
    {
      typedef search::SearchMove SearchMove;
      ~SearchMoveSet();
      /** 
       * ̤Ͽäꡤ¸Ψ⤫äϿ
       * @return Ͽɤ. 
       * ֤pointerϤdangling ˤʤ뤳Ȥ(ƥ饹vectorȤ)
       */
      SearchMove *assignIfBetter(const MoveLogProb& move, int margin=0)
      {
	SearchMove *recorded_move = find(move.getMove());
	if (recorded_move)
	{
	  // ˤ⤤Ψμ꤬äƤϿʤ
	  // 㤤ΨμϾ񤭤
	  if (recorded_move->moveLogProb().getLogProb() 
	      <= (move.getLogProb() + margin))
	    return 0;
	  *recorded_move = SearchMove(move, recorded_move->record);
	  return recorded_move;
	}
	return insertNoCheck(SearchMove(move));
      }
      bool isValidAll() const;
      void dump(std::ostream&) const;
      bool hasOnlyPass() const
      {
	const_iterator p = begin();
	if (p == end())
	  return false;
	return (p->getMove().isPass() && (++p == end()));
      }
    };

  } // namespace search
  using search::SearchMoveSet;
} // namespace osl


#endif /* _SEARCHMOVESET_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
