#ifndef _SPARSEINSTANCE_H
#define _SPARSEINSTANCE_H
#include "osl/stl/vector.h"
#include "osl/misc/fixedCapacityVector.h"
#include <iosfwd>
namespace osl
{
  namespace stat
  {
    struct SparseElement
    {
      unsigned int index;
      int value;
      /**
       * ѿϽʤΤ
       */
      SparseElement()
      {
      }
      SparseElement(unsigned int i, int v) : index(i), value(v)
      {
      }
    };
    struct SparseInstance : public vector<SparseElement> 
    {
      double dot_product(const double *weight, double initial=0) const
      {
	double sum = initial;
	for (const_iterator p=begin(); p!=end(); ++p)
	  sum += p->value * weight[p->index];
	return sum;
      }
    };
    std::ostream& operator<<(std::ostream&, const SparseInstance&);

    template <int SIZE>
    struct SparseInstanceFixed
      : public FixedCapacityVector<SparseElement, SIZE>
    {
    };

    typedef vector<SparseInstance> SparseInstanceVector;
  } // namespace stat
} // namespace osl

#endif /* _SPARSEINSTANCE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
