/* standardMoveGenerator.cc
 */
#include "osl/category/standardMoveGenerator.h"
#include "osl/category/categoryListUtil.h"
#include "osl/category/categoryListUtil.tcc"
#include "osl/category/classify.tcc"
#include "osl/category/probTable.tcc"
#include "osl/state/numEffectState.h"
#include "osl/search/searchMoveSet.h"

namespace osl
{
  namespace category
  {
    // explicit instantiation
    template void CategoryListUtil::
    gatherAllMoves<StandardMoveGenerator>(const CategoryEnv&, MoveLogProbSet&);
    template void CategoryListUtil::
    gatherAllMoves<StandardMoveGenerator>(const CategoryEnv&, SearchMoveSet&);
#ifdef NEED_EXTRA_TEMPLATE_INSTANTIATION
    template void CategoryListUtil::generate<BigramAttack>(CategoryEnv const&, osl::container::MoveLogProbVector&);
    template void CategoryListUtil::generate<BreakThreatmate>(CategoryEnv const&, osl::container::MoveLogProbVector&);
    template void CategoryListUtil::generate<ImmediateEscape>(CategoryEnv const&, osl::container::MoveLogProbVector&);
    template void CategoryListUtil::generate<AddEffectToLastMove>(CategoryEnv const&, osl::container::MoveLogProbVector&);
    template void CategoryListUtil::generate<Escape<ROOK> >(CategoryEnv const&, osl::container::MoveLogProbVector&);
    template void CategoryListUtil::generate<Escape<BISHOP> >(CategoryEnv const&, osl::container::MoveLogProbVector&);
    template void CategoryListUtil::generate<LegacyClassifier>(CategoryEnv const&, osl::container::MoveLogProbVector&);
#endif

  } // namespace category
} // namespace category

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
