#include "osl/checkmate/twinTable.h"
#include "osl/checkmate/twinList.h"
#include "osl/stl/hash_set.h"

namespace osl
{
  namespace checkmate
  {
    static const int initial_capacity = 100;

    /**
     * set ˤ줿ǡΰѹ뤿 mutable wrapper.
     * set Ʊ path ǸΤpath ѹʤ
     * ݤ.
     * TODO: ܼŪˤ hash_map ¤饹٤
     */
    struct TwinAgeMutable
    {
      mutable TwinAgeEntry body;
      TwinAgeMutable(const TwinAgeEntry& e) : body(e)
      {
      }
    };
    
    struct TwinPathHash
    {
      unsigned long operator()(const TwinAgeMutable& e) const
      {
	return e.body.entry.path.getPath();
      }
    };
    struct TwinPathEqual
    {
      bool operator()(const TwinAgeMutable& l, const TwinAgeMutable& r) const
      {
	return l.body.entry.path == r.body.entry.path;
      }
    };

    typedef hash_set<TwinAgeMutable,TwinPathHash,TwinPathEqual> hash_set_t;

    struct TwinTable::Table : public hash_set_t
    {
      explicit Table(size_t capacity) : hash_set_t(capacity)
      {
      }
    };
  } // namespace checkmate
} // namespace osl

osl::checkmate::  
TwinTable::TwinTable() : table(new Table(initial_capacity))
{
}

osl::checkmate::  
TwinTable::~TwinTable()
{
}

void osl::checkmate::
TwinTable::addTwin(const TwinEntry& e)
{
  const TwinAgeEntry ae(e.path, e.move, e.loopTo);
  std::pair<Table::iterator,bool> ib = table->insert(TwinAgeMutable(ae));
  if (! ib.second) 
  {
    ib.first->body.setTwinEntry(e);
  }
}

void osl::checkmate::  
TwinTable::clearTwins()
{
  table->clear();
}

const osl::checkmate::TwinEntry * osl::checkmate::  
TwinTable::findTwin(const PathEncoding& key) const
{
  Table::const_iterator p=table->find(TwinAgeMutable(TwinAgeEntry(key))); 
  if ((p == table->end()) 
      || (! p->body.hasTwinEntry()))
    return 0;
  return &(p->body.entry);
}

osl::checkmate::TwinAgeEntry& osl::checkmate::  
TwinTable::allocateTwin(const PathEncoding& key)
{
  return table->insert(TwinAgeMutable(TwinAgeEntry((key)))).first->body;
}

size_t osl::checkmate::  
TwinTable::size() const
{
  return table->size();
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
