#include "osl/container/moveLogProbVector.h"
#include <algorithm>
#include <iostream>

// ̩äɬפǤϤʤ
// #define RIGID_SORT_OF_MOVE

std::ostream& osl::container::operator<<(std::ostream& os,MoveLogProbVector const& mv)
{
  os<< "LogProbVector" << std::endl;
  for(MoveLogProbVector::const_iterator p=mv.begin(); p!=mv.end(); ++p)
  {
    os << *p << std::endl;
  }
  return os << std::endl;
}

namespace osl
{
  template <bool isLess>
  struct LogProbCompare
  {
    bool operator()(const MoveLogProb& l, const MoveLogProb& r) const
    {
#ifdef RIGID_SORT_OF_MOVE
      if (l.getLogProb() != r.getLogProb())
      {
#endif
	if (isLess)
	  return l.getLogProb() < r.getLogProb();
	else
	  return l.getLogProb() > r.getLogProb();
#ifdef RIGID_SORT_OF_MOVE
      }
      return l.getMove() > r.getMove();
#endif
    }
  };

  void MoveLogProbVector::sortByProbability()
  {
    std::sort(begin(), end(), LogProbCompare<true>());
  }
  void MoveLogProbVector::sortByProbabilityReverse()
  {
    std::sort(begin(), end(), LogProbCompare<false>());
  }
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
