/* piecePairRawTable.cc
 */
#include "osl/eval/ppair/piecePairRawEval.h"
#include "osl/eval/ppair/piecePairEval.tcc"
#include <boost/static_assert.hpp>
#include <algorithm>
#include <fstream>
#include <iostream>

namespace osl
{
  namespace eval
  {
    namespace ppair
    {
      BOOST_STATIC_ASSERT(PiecePairIndex::maxPtypeOIndex == 32);
      // roundup  2^n  2 ʾǤ뤳Ȥγǧ
      BOOST_STATIC_ASSERT((PiecePairEvalBase::ROUND_UP 
			   & (PiecePairEvalBase::ROUND_UP-1))
			  == 0);
      BOOST_STATIC_ASSERT(PiecePairEvalBase::ROUND_UP >= 2);

      template class PiecePairEvalTableBase<PiecePairRawTable>;
      template class PiecePairEval<PiecePairRawEval,PiecePairRawTable>;
    } // namespace ppair
  } // namespace eval
} // namespace osl

osl::eval::ppair::
PiecePairRawTable::PiecePairRawTable()
{
}

osl::eval::ppair::
PiecePairRawTable::~PiecePairRawTable()
{
}

void osl::eval::ppair::
PiecePairRawTable::writeInBinaryFile(const char *filename) const
{
  std::ofstream os(filename);
  os.write(reinterpret_cast<const char*>(&*values.begin()), sizeof(values));
}

bool osl::eval::ppair::
PiecePairRawTable::
loadFromBinaryFile(const char *filename) const
{
  std::cerr << "PiecePairRawTable loading  " << filename << "\n";
  std::ifstream is(filename);
  is.read(reinterpret_cast<char*>(&*values.begin()), sizeof(values));
  if (! is)
    return false;

  return true;
}

bool osl::eval::ppair::
PiecePairRawTable::
setUp(const char *filename) const
{
  static std::string filename_memory;
  if (! filename_memory.empty())
  {
    if (filename_memory != filename)
    {
      std::cerr << "PiecePairRawTable: don't load " << filename 
		<< ", since " << filename_memory
		<< " already loaded \n";
      return false;
    }
    return true;
  }
  filename_memory = filename;
  return loadFromBinaryFile(filename);
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
