/* searchMoveSet.cc
 */
#include "osl/search/searchMoveSet.h"
#include "osl/search/simpleHashRecord.h"
#include "osl/record/csa.h"
#include <iostream>

osl::search::
SearchMoveSet::~SearchMoveSet()
{
  assert(isValidAll());
}

bool osl::search::
SearchMoveSet::isValidAll() const
{
  for (const_iterator p=begin(); p!=end(); ++p)
  {
    if (! p->getMove().isValidOrPass())
      return false;
  }
  return true;
}

void osl::search::
SearchMoveSet::dump(std::ostream& os) const
{
  size_t i=0;
  for (const_iterator p=begin(); p!=end(); ++p, ++i)
  {
    os << 'M' << i << "\t" << record::csa::show(p->getMove());
    os << " " << p->getLogProb();
    
#ifndef NDEBUG
    os << "\t" << p->record;
#  if 0
    os << " " << &*p;
#  endif
#endif
    if (p->record)
    {
      os << "\t";
      if (p->record->hasLowerBound(0))
	os <<  p->record->lowerBound();
      else 
	os << "*";
      os << " < ";
      if (p->record->hasUpperBound(0))
	os <<  p->record->upperBound();
      else 
	os << "*";
    }
    os << "\n";
    assert(p->getMove().isValidOrPass());
  }
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
