#include "osl/category/capture.h"
#include "osl/record/csaString.h"
#include "osl/state/numEffectState.h"
#include "osl/container/moveVector.h"

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <iostream>

class CategoryCaptureTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(CategoryCaptureTest);
  CPPUNIT_TEST(testGenerate);
  CPPUNIT_TEST_SUITE_END();
 public:
  void testGenerate();
};


CPPUNIT_TEST_SUITE_REGISTRATION(CategoryCaptureTest);

using namespace osl;
using namespace osl::category;
extern bool isShortTest;

void CategoryCaptureTest::testGenerate()
{
  NumEffectState state(CsaString(
			 "P1+NY+TO *  *  *  * -OU-KE-KY\n"
			 "P2 *  *  *  *  * -GI-KI *  *\n"
			 "P3 * +RY *  * +UM * -KI-FU-FU\n"
			 "P4 *  * +FU-FU *  *  *  *  *\n"
			 "P5 *  * -KE * +FU *  * +FU *\n"
			 "P6-KE *  * +FU+GI-FU *  * +FU\n"
			 "P7 *  * -UM *  *  *  *  *  *\n"
			 "P8 *  *  *  *  *  *  *  *  * \n"
			 "P9 * +OU * -GI *  *  *  * -NG\n"
			 "P+00HI00KI00KE00KY00FU00FU00FU00FU00FU00FU\n"
			 "P-00KI00KY00FU00FU\n"
			 "P-00AL\n"
			 "+\n").getInitialState());

  MoveVector moves;
  CategoryEnv env(&state, 1000, 0);
  Capture<SILVER>::generate(env, moves);
  CPPUNIT_ASSERT(moves.size() > 0);
  // Ȥ̣٤ɤʤΤǸ
  if (! isShortTest)
    std::cout << moves;
  moves.clear();

  CategoryEnv env2(&state, 500, 0);
  Capture<PAWN>::generate(env2, moves);
  CPPUNIT_ASSERT(moves.size() > 0);
  if (! isShortTest)
    std::cout << moves;
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
