/* quiescenceRecord.t.cc
 */
#include "osl/search/quiescenceRecord.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

class QuiescenceRecordTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(QuiescenceRecordTest);
  CPPUNIT_TEST(testFlags);
  CPPUNIT_TEST_SUITE_END();
public:
  void testFlags();
};

CPPUNIT_TEST_SUITE_REGISTRATION(QuiescenceRecordTest);

using namespace osl;
using namespace osl::search;

void QuiescenceRecordTest::testFlags()
{
  QuiescenceFlags flags;
  CPPUNIT_ASSERT(! flags.isGenerated(PAWN));
  flags.recordGeneration(PAWN);
  CPPUNIT_ASSERT(flags.isGenerated(PAWN));

  CPPUNIT_ASSERT(! flags.isGenerated(ROOK));
  flags.recordGeneration(ROOK);
  CPPUNIT_ASSERT(flags.isGenerated(ROOK));
  CPPUNIT_ASSERT(flags.isGenerated(PAWN));

  CPPUNIT_ASSERT(! flags.isGenerated(QuiescenceFlags::KING_ESCAPE));
  flags.recordGeneration(QuiescenceFlags::KING_ESCAPE);
  CPPUNIT_ASSERT(flags.isGenerated(QuiescenceFlags::KING_ESCAPE));
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
